searchData={"items":[{"type":"module","title":"ExToolkit","doc":"[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"ExToolkit.html"},{"type":"module","title":"Installation - ExToolkit","doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.12.7\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"ExToolkit.html#module-installation"},{"type":"module","title":"ExToolkit.Bench","doc":"Utility for quick and simple benchmarking functions in Elixir.","ref":"ExToolkit.Bench.html"},{"type":"macro","title":"ExToolkit.Bench.timeit/2","doc":"Benchmarks the execution time of a piece of code. It should be used only in\nreally simple cases.","ref":"ExToolkit.Bench.html#timeit/2"},{"type":"macro","title":"Examples - ExToolkit.Bench.timeit/2","doc":"iex> timeit \"Sleep for a while\", do: :timer.sleep(1000)\n  Executed Sleep for a while in 1.00 seconds","ref":"ExToolkit.Bench.html#timeit/2-examples"},{"type":"module","title":"ExToolkit.Ecto.Changeset","doc":"Helper functions that extend `Ecto.Changeset` functionality.","ref":"ExToolkit.Ecto.Changeset.html"},{"type":"function","title":"ExToolkit.Ecto.Changeset.validate_url/3","doc":"Validates the structure of a URL field in an Ecto changeset. It does not make it required field.\n\nIf the `field` in the `changeset` is a URL, this function ensures that it has a scheme (defaulting to \"https://\" if\nnone is present), and then checks the URL's structure against a regular expression.\n\nIf the URL's structure is invalid, the `error_message` is attached to the `field` in the `changeset`'s errors.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Changeset.validate_url/3","doc":"- `changeset`: The Ecto changeset containing the URL to validate.\n  - `field`: The key (atom) for the field in the changeset containing the URL.\n  - `error_message`: The error message to attach to the `field` in the `changeset` if the URL is invalid.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Changeset.validate_url/3","doc":"iex> types = %{url: :string}\n    iex> params = %{url: \"https://www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: nil}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"some@invalid_url\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"Just some random text\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-examples"},{"type":"module","title":"ExToolkit.Ecto.ObjectID","doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.ObjectID.html"},{"type":"module","title":"Examples - ExToolkit.Ecto.ObjectID","doc":"@primary_key {:id, ExToolkit.Ecto.ObjectID, prefix: \"user\", autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.ObjectID","ref":"ExToolkit.Ecto.ObjectID.html#module-examples"},{"type":"module","title":"Resources - ExToolkit.Ecto.ObjectID","doc":"- https://dev.to/stripe/designing-apis-for-humans-object-ids-3o5a\n  - https://danschultzer.com/posts/prefixed-base62-uuidv7-object-ids-with-ecto","ref":"ExToolkit.Ecto.ObjectID.html#module-resources"},{"type":"type","title":"ExToolkit.Ecto.ObjectID.opts/0","doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:opts/0"},{"type":"type","title":"ExToolkit.Ecto.ObjectID.t/0","doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:t/0"},{"type":"module","title":"ExToolkit.Ecto.Paginator","doc":"Provides functionality for paginating Ecto queries. It offers a simple and\nflexible way to paginate large result sets, supporting both default and\ncustom pagination options.","ref":"ExToolkit.Ecto.Paginator.html"},{"type":"module","title":"Usage - ExToolkit.Ecto.Paginator","doc":"To use this paginator in your module, you call `use ExToolkit.Ecto.Paginator`.\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo, otp_app: :my_app\n      use ExToolkit.Ecto.Paginator\n    end\n\nThe default page size is 25 but you can override it by passing a `page_size`.\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo, otp_app: :my_app\n      use ExToolkit.Ecto.Paginator, page_size: 30\n    end","ref":"ExToolkit.Ecto.Paginator.html#module-usage"},{"type":"module","title":"Use without macros - ExToolkit.Ecto.Paginator","doc":"If you wish to avoid use of macros or you wish to use a different name for\nthe pagination function you can define your own function like so:\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo, otp_app: :my_app\n\n      def my_paginate_function(queryable, page, opts \\\\ [], repo_opts \\\\ []) do\n        defaults = [page_size: 12] # Default options of your choice here\n        opts = Keyword.merge(defaults, opts)\n        ExToolkit.Ecto.Paginator.paginate(queryable, __MODULE__, page, opts, repo_opts)\n      end\n    end","ref":"ExToolkit.Ecto.Paginator.html#module-use-without-macros"},{"type":"type","title":"ExToolkit.Ecto.Paginator.option/0","doc":"","ref":"ExToolkit.Ecto.Paginator.html#t:option/0"},{"type":"type","title":"ExToolkit.Ecto.Paginator.options/0","doc":"","ref":"ExToolkit.Ecto.Paginator.html#t:options/0"},{"type":"type","title":"ExToolkit.Ecto.Paginator.page/0","doc":"","ref":"ExToolkit.Ecto.Paginator.html#t:page/0"},{"type":"type","title":"ExToolkit.Ecto.Paginator.page/1","doc":"","ref":"ExToolkit.Ecto.Paginator.html#t:page/1"},{"type":"function","title":"ExToolkit.Ecto.Paginator.paginate/5","doc":"Paginates an Ecto query and returns a map with pagination metadata.","ref":"ExToolkit.Ecto.Paginator.html#paginate/5"},{"type":"function","title":"Arguments - ExToolkit.Ecto.Paginator.paginate/5","doc":"- `queryable`: The Ecto queryable (e.g., `Repo.all(User)`).\n- `repo`: The repository to execute the query.\n- `page`: The page number to fetch (starts at 1).\n- `opts`: A keyword list of options, including the `:page_size` option (default is 25).\n- `repo_opts`: Ecto-specific options, see [ecto docs](https://hexdocs.pm/ecto/Ecto.Repo.html#c:all/2-options) to learn about all available options.","ref":"ExToolkit.Ecto.Paginator.html#paginate/5-arguments"},{"type":"function","title":"Returns - ExToolkit.Ecto.Paginator.paginate/5","doc":"A map containing the following keys:\n- `:data` - The list of items for the current page.\n- `:current_page` - The current page number.\n- `:total_count` - The total number of items in the query.\n- `:total_pages` - The total number of pages based on the page size.\n- `:has_next_page` - Whether there is a next page.\n- `:has_prev_page` - Whether there is a previous page.\n- `:is_first_page` - Whether the current page is the first page.\n- `:is_last_page` - Whether the current page is the last page.","ref":"ExToolkit.Ecto.Paginator.html#paginate/5-returns"},{"type":"module","title":"ExToolkit.Ecto.Query","doc":"A helper module that extend `Ecto.Query` functionality.","ref":"ExToolkit.Ecto.Query.html"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_filters/2","doc":"","ref":"ExToolkit.Ecto.Query.html#apply_filters/2"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_options/2","doc":"Applies a series of operations to an Ecto query.","ref":"ExToolkit.Ecto.Query.html#apply_options/2"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.apply_options/2","doc":"- `query`: The Ecto query to which operations should be applied.\n- `opts`: A list of operations to apply. Each operation is a tuple where the first element is the operation name\n  and the second element is the value to use for that operation.\n\nThe following operations are supported:\n\n- `{:where, filters}`: Adds a `where` clause to the query.\n- `{:select, fields}`: Adds a `select` clause to the query.\n- `{:order_by, criteria}`: Adds an `order_by` clause to the query.\n- `{:limit, criteria}`: Adds a `limit` clause to the query.\n- `{:preload, preload}`: Adds a `preload` clause to the query.\n\nInvalid options are ignored from query result.","ref":"ExToolkit.Ecto.Query.html#apply_options/2-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.apply_options/2","doc":"iex> query = from(u in \"users\")\n    iex> apply_options(query, where: [age: 18], select: [:id, :email])\n    #Ecto.Query \n\n    iex> query = from(u in \"users\")\n    iex> filters = [\n    ...> {:where, [age: 18]},\n    ...> {:order_by, [desc: :age]},\n    ...> {:select, [:id, :email]},\n    ...> {:limit, 10},\n    ...> {:preload, :posts},\n    ...>]\n    iex> apply_options(query, filters)\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_options/2-examples"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_pagination/3","doc":"Applies pagination to an Ecto query. It calculates the correct offset based on the page number and limits the number\nof results returned by the query to the specified page size.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.apply_pagination/3","doc":"- `query` - An Ecto.Query or any data structure implementing the `Ecto.Queryable` protocol.\n  - `page` - The page number for which data is requested. Can be a positive integer or a string representing an integer.\n  - `page_size` - The number of items to be included on each page. Can be a positive integer or a string representing an integer.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-parameters"},{"type":"function","title":"Returns - ExToolkit.Ecto.Query.apply_pagination/3","doc":"- An `Ecto.Queryable.t()` with pagination applied.\n\nThis function supports page and page_size values passed as integers or strings. If strings are provided, they are\nconverted to integers. If the conversion is not possible, an error will occur.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-returns"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.apply_pagination/3","doc":"iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 1, 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, \"2\", 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 4, \"15\")\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-examples"},{"type":"function","title":"ExToolkit.Ecto.Query.in_range/3","doc":"Filters a query to only include rows where the specified column's value is within a provided range.","ref":"ExToolkit.Ecto.Query.html#in_range/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.in_range/3","doc":"- `query`: The Ecto query to filter.\n- `column`: The column on which to apply the range filter.\n- `min..max`: The range of values to filter on.","ref":"ExToolkit.Ecto.Query.html#in_range/3-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.in_range/3","doc":"iex> query = from(u in \"users\", select: u.age)\n    iex> in_range(query, :age, 18..30)\n    #Ecto.Query = ^18 and u0.age <= ^30, select: u0.age>","ref":"ExToolkit.Ecto.Query.html#in_range/3-examples"},{"type":"type","title":"ExToolkit.Ecto.Query.option/0","doc":"","ref":"ExToolkit.Ecto.Query.html#t:option/0"},{"type":"type","title":"ExToolkit.Ecto.Query.options/0","doc":"","ref":"ExToolkit.Ecto.Query.html#t:options/0"},{"type":"function","title":"ExToolkit.Ecto.Query.sanitize_options/1","doc":"","ref":"ExToolkit.Ecto.Query.html#sanitize_options/1"},{"type":"module","title":"ExToolkit.Ecto.SlugID","doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.SlugID.html"},{"type":"module","title":"Examples - ExToolkit.Ecto.SlugID","doc":"@primary_key {:id, ExToolkit.Ecto.SlugID, autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.SlugID","ref":"ExToolkit.Ecto.SlugID.html#module-examples"},{"type":"function","title":"ExToolkit.Ecto.SlugID.generate/0","doc":"","ref":"ExToolkit.Ecto.SlugID.html#generate/0"},{"type":"type","title":"ExToolkit.Ecto.SlugID.t/0","doc":"","ref":"ExToolkit.Ecto.SlugID.html#t:t/0"},{"type":"module","title":"ExToolkit.Encode.Base62UUID","doc":"A utility module providing functions to encode and decode UUIDs using Base62 encoding.\n\nThe Base62 encoding allows representing UUIDs in a more compact form, reducing their length from 32 to 22 characters.\nThis module supports converting standard UUIDs (as strings) to Base62 encoded UUIDs and vice-versa.","ref":"ExToolkit.Encode.Base62UUID.html"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.base62_uuid_length/0","doc":"Gets @base62_uuid_length.","ref":"ExToolkit.Encode.Base62UUID.html#base62_uuid_length/0"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.base62_uuid_length/0","doc":"iex> Elixir.ExToolkit.Encode.Base62UUID.base62_uuid_length()\n    22","ref":"ExToolkit.Encode.Base62UUID.html#base62_uuid_length/0-examples"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.decode/1","doc":"Decodes a Base62 encoded string into a UUID.\n\nThis function is the inverse of `encode/1`. It converts a Base62 encoded string back to its original UUID form.","ref":"ExToolkit.Encode.Base62UUID.html#decode/1"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.decode/1","doc":"iex> Base62UUID.decode(\"2FJ5BAFmLzL78YNqBSsS9I\")\n    {:ok, \"49d3793a-2f87-4bcb-aa96-be5892848ae0\"}","ref":"ExToolkit.Encode.Base62UUID.html#decode/1-examples"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.encode/1","doc":"Encodes a UUID into a Base62 encoded string.","ref":"ExToolkit.Encode.Base62UUID.html#encode/1"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.encode/1","doc":"iex> Base62UUID.encode(\"49d3793a-2f87-4bcb-aa96-be5892848ae0\")\n    \"2FJ5BAFmLzL78YNqBSsS9I\"","ref":"ExToolkit.Encode.Base62UUID.html#encode/1-examples"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.uuid_length/0","doc":"Gets @uuid_length.","ref":"ExToolkit.Encode.Base62UUID.html#uuid_length/0"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.uuid_length/0","doc":"iex> Elixir.ExToolkit.Encode.Base62UUID.uuid_length()\n    32","ref":"ExToolkit.Encode.Base62UUID.html#uuid_length/0-examples"},{"type":"module","title":"ExToolkit.Git","doc":"This module provides utility functions for interacting with Git.","ref":"ExToolkit.Git.html"},{"type":"function","title":"ExToolkit.Git.revision_hash/0","doc":"Retrieves the current Git revision hash.","ref":"ExToolkit.Git.html#revision_hash/0"},{"type":"module","title":"ExToolkit.Gravatar","doc":"Interface to Gravatar API.\n\nSee [Gravatar API documentation](https://docs.gravatar.com/api/avatars/images/) to learn more.","ref":"ExToolkit.Gravatar.html"},{"type":"type","title":"ExToolkit.Gravatar.avatar_options/0","doc":"","ref":"ExToolkit.Gravatar.html#t:avatar_options/0"},{"type":"function","title":"ExToolkit.Gravatar.avatar_url/2","doc":"Generates a Gravatar image URL for the given email address.","ref":"ExToolkit.Gravatar.html#avatar_url/2"},{"type":"function","title":"Options - ExToolkit.Gravatar.avatar_url/2","doc":"* `:size` - size of the image (1..2048), default: 256\n  * `:default` - a URL-encoded image or one of: initials, color, 404, mp, identicon, monsterid, wavatar, retro, robohash or blank, default: mm\n  * `:rating` - rating (g, pg, r, x), default: g\n  * `:initials` - initials for the initials default\n  * `:name` - name to generate initials","ref":"ExToolkit.Gravatar.html#avatar_url/2-options"},{"type":"function","title":"Examples - ExToolkit.Gravatar.avatar_url/2","doc":"iex> avatar_url(\"john@example.com\")\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?d=mm&s=256&r=g\"\n\n    iex> avatar_url(\"john@example.com\", size: 128)\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?d=mm&s=128&r=g\"\n\n    iex> avatar_url(\"john@example.com\", default: \"identicon\")\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?d=identicon&s=256&r=g\"\n\n    iex> avatar_url(\"john@example.com\", default: \"https://example.com/avatar.png\")\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?d=https%3A%2F%2Fexample.com%2Favatar.png&s=256&r=g\"","ref":"ExToolkit.Gravatar.html#avatar_url/2-examples"},{"type":"module","title":"ExToolkit.Kernel","doc":"Basic language primitives to ease development flow.","ref":"ExToolkit.Kernel.html"},{"type":"macro","title":"ExToolkit.Kernel.defattr/1","doc":"Defines a module attribute and a function to get it. Inspired by `attr_reader`\nfrom ruby.","ref":"ExToolkit.Kernel.html#defattr/1"},{"type":"macro","title":"Examples - ExToolkit.Kernel.defattr/1","doc":"iex> defmodule ExampleModule do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr foo: :bar\n    ...> end\n    iex> ExampleModule.foo()\n    :bar\n\n    iex> defmodule ExampleModule2 do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr name: \"ExToolkit\", version: \"1.0.0\"\n    ...> end\n    iex> %{name: ExampleModule2.name(), version: ExampleModule2.version()}\n    %{name: \"ExToolkit\", version: \"1.0.0\"}\n\n    iex> defmodule ExampleModule3 do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr [version: Version.parse!(\"1.0.1\")]\n    ...> end\n    iex> ExampleModule3.version()\n    %Version{major: 1, minor: 0, patch: 1}","ref":"ExToolkit.Kernel.html#defattr/1-examples"},{"type":"function","title":"ExToolkit.Kernel.error/0","doc":"Returns the atom `:error`.","ref":"ExToolkit.Kernel.html#error/0"},{"type":"function","title":"Example - ExToolkit.Kernel.error/0","doc":"iex> error()\n    :error","ref":"ExToolkit.Kernel.html#error/0-example"},{"type":"function","title":"ExToolkit.Kernel.error/1","doc":"Wraps a given value in a tuple tagged with `:error`.","ref":"ExToolkit.Kernel.html#error/1"},{"type":"function","title":"Examples - ExToolkit.Kernel.error/1","doc":"iex> error(\"something went wrong\")\n    {:error, \"something went wrong\"}\n\n    iex> error(404)\n    {:error, 404}","ref":"ExToolkit.Kernel.html#error/1-examples"},{"type":"function","title":"ExToolkit.Kernel.noreply/1","doc":"Wraps a given value in a tuple tagged with `:noreply`.","ref":"ExToolkit.Kernel.html#noreply/1"},{"type":"function","title":"Examples - ExToolkit.Kernel.noreply/1","doc":"iex> noreply(\"something went wrong\")\n    {:noreply, \"something went wrong\"}\n\n    iex> noreply(404)\n    {:noreply, 404}","ref":"ExToolkit.Kernel.html#noreply/1-examples"},{"type":"function","title":"ExToolkit.Kernel.ok/0","doc":"Returns the atom `:ok`.","ref":"ExToolkit.Kernel.html#ok/0"},{"type":"function","title":"Example - ExToolkit.Kernel.ok/0","doc":"iex> ok()\n    :ok","ref":"ExToolkit.Kernel.html#ok/0-example"},{"type":"function","title":"ExToolkit.Kernel.ok/1","doc":"Wraps a given value in a tuple tagged with `:ok`.","ref":"ExToolkit.Kernel.html#ok/1"},{"type":"function","title":"Examples - ExToolkit.Kernel.ok/1","doc":"iex> ok(42)\n    {:ok, 42}\n\n    iex> ok(\"hello\")\n    {:ok, \"hello\"}","ref":"ExToolkit.Kernel.html#ok/1-examples"},{"type":"type","title":"ExToolkit.Kernel.type/0","doc":"","ref":"ExToolkit.Kernel.html#t:type/0"},{"type":"function","title":"ExToolkit.Kernel.type_of/1","doc":"Determines the type of the given term.","ref":"ExToolkit.Kernel.html#type_of/1"},{"type":"function","title":"Examples - ExToolkit.Kernel.type_of/1","doc":"iex> type_of(3.14)\n    :float\n\n    iex> type_of(42)\n    :integer\n\n    iex> type_of(true)\n    :boolean\n\n    iex> type_of(:atom)\n    :atom\n\n    iex> type_of(\"string\")\n    :binary\n\n    iex> type_of([1, 2, 3])\n    :list\n\n    iex> type_of({:ok, 1})\n    :tuple\n\n    iex> type_of(%{})\n    :map\n\n    iex> type_of(fn -> :ok end)\n    :function\n\n    iex> type_of(%URI{})\n    :struct\n\n    iex> type_of(%RuntimeError{})\n    :exception\n\n    iex> type_of(self())\n    :pid\n\n    iex> type_of(nil)\n    nil","ref":"ExToolkit.Kernel.html#type_of/1-examples"},{"type":"function","title":"ExToolkit.Kernel.validate_opts!/2","doc":"Validates the given options against the given defaults.","ref":"ExToolkit.Kernel.html#validate_opts!/2"},{"type":"function","title":"Examples - ExToolkit.Kernel.validate_opts!/2","doc":"iex> validate_opts!([foo: :bar], [foo: :baz])\n    %{foo: :bar}\n\n    iex> validate_opts!([], [foo: :baz])\n    %{foo: :baz}\n\n    iex> validate_opts!([foo: :bar, bar: :baz], %{foo: :bar})\n    ** (ArgumentError) unknown keys [:bar] in [foo: :bar, bar: :baz], the allowed keys are: [:foo]\n\n    iex> validate_opts!(%{foo: :bar, bar: :baz}, %{foo: :bar, bar: :baz})\n    %{foo: :bar, bar: :baz}\n\n    iex> validate_opts!(%{foo: :bar}, [foo: :bar])\n    %{foo: :bar}\n\n    iex> validate_opts!(%{foo: :bar}, [foo: :baz, bar: :zad])\n    %{foo: :bar, bar: :zad}","ref":"ExToolkit.Kernel.html#validate_opts!/2-examples"},{"type":"module","title":"ExToolkit.Map","doc":"This module provides utilities for working with maps.","ref":"ExToolkit.Map.html"},{"type":"function","title":"ExToolkit.Map.deep_from_struct/1","doc":"Recursively converts a struct into a plain map, transforming all nested structs,\nmaps, and lists along the way.\n\nOnly accepts a struct at the top level. If a non-struct is passed, it will raise a `FunctionClauseError`.\n\nIf you don't want to do a deep recursive conversion you should use `Map.from_struct/1`.","ref":"ExToolkit.Map.html#deep_from_struct/1"},{"type":"function","title":"Examples - ExToolkit.Map.deep_from_struct/1","doc":"iex> outer = %URI{host: \"test\", scheme: %{info: %URI{host: 42, authority: nil, fragment: nil, path: nil, port: nil, query: nil, scheme: nil, userinfo: nil}}}\n    iex> ExToolkit.Map.deep_from_struct(outer)\n    %{\n      host: \"test\",\n      scheme: %{info: %{host: 42, authority: nil, fragment: nil, path: nil, port: nil, query: nil, scheme: nil, userinfo: nil}},\n      authority: nil,\n      fragment: nil,\n      path: nil,\n      port: nil,\n      query: nil,\n      userinfo: nil\n    }","ref":"ExToolkit.Map.html#deep_from_struct/1-examples"},{"type":"module","title":"ExToolkit.Naming","doc":"This module encapsulates common tasks related to processing personal names in\na standardized format. This module treats names as case-insensitive and\nreturns results in a formatted, readable way.","ref":"ExToolkit.Naming.html"},{"type":"function","title":"ExToolkit.Naming.capitalize/1","doc":"Capitalizes the first letter of each word in a name.","ref":"ExToolkit.Naming.html#capitalize/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.capitalize/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#capitalize/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.capitalize/1","doc":"iex> Naming.capitalize(nil)\n    \"\"\n\n    iex> Naming.capitalize(\"\")\n    \"\"\n\n    iex> Naming.capitalize(\"john doe\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"JOHN DOE\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"john nommensen duchac\")\n    \"John Nommensen Duchac\"","ref":"ExToolkit.Naming.html#capitalize/1-examples"},{"type":"function","title":"ExToolkit.Naming.extract_first_last_name/1","doc":"Extracts and capitalizes the first and last names from a given name.","ref":"ExToolkit.Naming.html#extract_first_last_name/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.extract_first_last_name/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_first_last_name/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.extract_first_last_name/1","doc":"iex> Naming.extract_first_last_name(nil)\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"\")\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"john\")\n    \"John\"\n\n    iex> Naming.extract_first_last_name(\"john doe smith\")\n    \"John Smith\"","ref":"ExToolkit.Naming.html#extract_first_last_name/1-examples"},{"type":"function","title":"ExToolkit.Naming.extract_initials/1","doc":"Extracts the initials from a given name.\n\nThis function takes a name (a string of one or more words), and extracts the\nfirst letter of the first name and the family name.","ref":"ExToolkit.Naming.html#extract_initials/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.extract_initials/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_initials/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.extract_initials/1","doc":"iex> Naming.extract_initials(nil)\n    \"\"\n\n    iex> Naming.extract_initials(\"\")\n    \"\"\n\n    iex> Naming.extract_initials(\"John\")\n    \"J\"\n\n    iex> Naming.extract_initials(\"John Doe\")\n    \"JD\"\n\n    iex> Naming.extract_initials(\"John Nommensen Duchac\")\n    \"JD\"","ref":"ExToolkit.Naming.html#extract_initials/1-examples"},{"type":"function","title":"ExToolkit.Naming.extract_short_name/1","doc":"Extracts and capitalizes the first and last names and then shortens the first name from a given name and.","ref":"ExToolkit.Naming.html#extract_short_name/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.extract_short_name/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_short_name/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.extract_short_name/1","doc":"iex> Naming.extract_short_name(nil)\n    \"\"\n\n    iex> Naming.extract_short_name(\"\")\n    \"\"\n\n    iex> Naming.extract_short_name(\"john\")\n    \"John\"\n\n    iex> Naming.extract_short_name(\"john doe smith\")\n    \"J. Smith\"\n\n    iex> Naming.extract_short_name(\"john doe smith (funny)\")\n    \"J. Smith\"","ref":"ExToolkit.Naming.html#extract_short_name/1-examples"},{"type":"function","title":"ExToolkit.Naming.shorten_firstname/1","doc":"Shortens the first name to its initial, while preserving the rest of the name.\n\nThis function takes a name (a string of one or more words), and reduces the first name to its initial.\nThe rest of the name is preserved. The initial is followed by a period and a space, and then the rest of the name.","ref":"ExToolkit.Naming.html#shorten_firstname/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.shorten_firstname/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#shorten_firstname/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.shorten_firstname/1","doc":"iex> Naming.shorten_firstname(nil)\n    \"\"\n\n    iex> Naming.shorten_firstname(\"\")\n    \"\"\n\n    iex> Naming.shorten_firstname(\"John\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"john\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"John Doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe jr\")\n    \"J. Doe Jr\"","ref":"ExToolkit.Naming.html#shorten_firstname/1-examples"},{"type":"function","title":"ExToolkit.Naming.shorten_lastname/1","doc":"Shortens the last name to its initial, while preserving the rest of the name.\n\nThis function takes a name (a string of one or more words), and reduces the last name to its initial.\nThe rest of the name is preserved. The initial is followed by a period and a space.","ref":"ExToolkit.Naming.html#shorten_lastname/1"},{"type":"function","title":"Arguments - ExToolkit.Naming.shorten_lastname/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#shorten_lastname/1-arguments"},{"type":"function","title":"Examples - ExToolkit.Naming.shorten_lastname/1","doc":"iex> Naming.shorten_lastname(nil)\n    \"\"\n\n    iex> Naming.shorten_lastname(\"\")\n    \"\"\n\n    iex> Naming.shorten_lastname(\"John\")\n    \"John\"\n\n    iex> Naming.shorten_lastname(\"john\")\n    \"John\"\n\n    iex> Naming.shorten_lastname(\"John Doe\")\n    \"John D.\"\n\n    iex> Naming.shorten_lastname(\"John Van Doe\")\n    \"John Van D.\"\n\n    iex> Naming.shorten_lastname(\"john doe\")\n    \"John D.\"","ref":"ExToolkit.Naming.html#shorten_lastname/1-examples"},{"type":"module","title":"ExToolkit.UiAvatars","doc":"A utility module to generate URLs for https://ui-avatars.com/ with customizable options.","ref":"ExToolkit.UiAvatars.html"},{"type":"function","title":"ExToolkit.UiAvatars.gravatar_safe_url/2","doc":"Generates a Gravatar-compatible avatar URL that falls back to a UI Avatars image\nif the user has no Gravatar. For all supported options, see `url/1`.","ref":"ExToolkit.UiAvatars.html#gravatar_safe_url/2"},{"type":"function","title":"Examples - ExToolkit.UiAvatars.gravatar_safe_url/2","doc":"iex> UiAvatars.gravatar_safe_url(\"john@example.com\", name: \"Jane Doe\", background: \"000000\", color: \"ffffff\")\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?size=256&d=https%3A%2F%2Fui-avatars.com%2Fapi%2FJane+Doe/256/000000/ffffff/2/0.5/false/true/false/png\"\n\n    iex> UiAvatars.gravatar_safe_url(\"john@example.com\", name: \"João Oliveira\", length: 3, font_size: 0.4)\n    \"https://www.gravatar.com/avatar/d4c74594d841139328695756648b6bd6?size=256&d=https%3A%2F%2Fui-avatars.com%2Fapi%2FJo%C3%A3o+Oliveira/256/f0e9e9/8b5d5d/3/0.4/false/true/false/png\"","ref":"ExToolkit.UiAvatars.html#gravatar_safe_url/2-examples"},{"type":"type","title":"ExToolkit.UiAvatars.options/0","doc":"","ref":"ExToolkit.UiAvatars.html#t:options/0"},{"type":"function","title":"ExToolkit.UiAvatars.url/1","doc":"Generates a UI Avatars image URL with the given options.","ref":"ExToolkit.UiAvatars.html#url/1"},{"type":"function","title":"Supported Options - ExToolkit.UiAvatars.url/1","doc":"- `:name` – The name used to generate initials for the avatar.\n  - `:length` – Number of characters in the initials (default: 2).\n  - `:rounded` – Whether the avatar should be circular (default: `false`).\n  - `:bold` – Whether the initials should be bold (default: `false`).\n  - `:background` – Hex color for the background (default: `\"f0e9e9\"`).\n  - `:color` – Hex color for the font (default: `\"8b5d5d\"`).\n  - `:uppercase` – Whether the initials should be uppercased (default: `true`).\n  - `:size` – Size of the image in pixels (default: `256`).\n  - `:font_size` – Font size as a float percentage (default: `0.5`).\n  - `:format` – The image format, `\"svg\"` or `\"png\"` (default: `\"svg\"`).","ref":"ExToolkit.UiAvatars.html#url/1-supported-options"},{"type":"function","title":"Examples - ExToolkit.UiAvatars.url/1","doc":"iex> UiAvatars.url(%{name: \"Jane Doe\", size: 128, rounded: true, format: \"png\", font_size: 1})\n    \"https://ui-avatars.com/api/?name=Jane+Doe&size=128&format=png&font-size=1&rounded=true\"\n\n    iex> UiAvatars.url(%{name: \"Elixir\", color: \"ffffff\", background: \"000000\", uppercase: false, bold: true})\n    \"https://ui-avatars.com/api/?name=Elixir&size=256&format=svg&uppercase=false&color=ffffff&font-size=0.5&background=000000&bold=true\"","ref":"ExToolkit.UiAvatars.html#url/1-examples"},{"type":"extras","title":"Elixir Toolkit","doc":"# Elixir Toolkit\n\n[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"readme.html"},{"type":"extras","title":"Installation - Elixir Toolkit","doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.12.8\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}